Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.IO
Imports System.Net

Module Module1

    Sub Main()
        VBAPI.Example()
    End Sub

    Public Class VBApi
        Private Shared Function UrlEncode(ByVal str As String) As String
            If str Is Nothing Then
                Return ""
            End If

            Dim enc As Encoding = Encoding.ASCII
            Dim result As New StringBuilder()

            For Each symbol As Char In str
                Dim bs As Byte() = enc.GetBytes(New Char() {symbol})
                For i As Integer = 0 To bs.Length - 1
                    Dim b As Byte = bs(i)
                    If b >= 48 AndAlso b < 58 OrElse b >= 65 AndAlso b < 65 + 26 OrElse b >= 97 AndAlso b < 97 + 26 Then
                        ' decode non numalphabet
                        result.Append(Encoding.ASCII.GetString(bs, i, 1))
                    Else
                        result.Append("%"c + [String].Format("{0:X2}", CInt(b)))
                    End If
                Next
            Next

            Return result.ToString()
        End Function

        Private Shared Function WebPost(ByVal url As String, ByVal ParamArray ps As String()) As String
            Try
                Dim request As HttpWebRequest = DirectCast(WebRequest.Create(url), HttpWebRequest)
                request.Proxy = GlobalProxySelection.GetEmptyWebProxy()
                Dim str As String = ""
                Dim i As Integer = 0
                While i + 1 < ps.Length
                    str += (UrlEncode(ps(i)) & "=") + UrlEncode(ps(i + 1)) & "&"
                    i += 2
                End While
                If str.EndsWith("&") Then
                    str = str.Substring(0, str.Length - 1)
                End If
                request.Method = "POST"
                request.ContentType = "application/x-www-form-urlencoded"
                Dim data As Byte() = Encoding.ASCII.GetBytes(str)
                request.ContentLength = data.Length
                Dim newStream As Stream = request.GetRequestStream()
                newStream.Write(data, 0, data.Length)

                Dim response As WebResponse = request.GetResponse()
                Dim sStream As Stream = response.GetResponseStream()
                Dim reader As New StreamReader(sStream)
                Dim retContent As String = reader.ReadToEnd()
                reader.Close()
                response.Close()
                newStream.Close()
                Return retContent
            Catch
                Return ""
            End Try
        End Function

        Public Shared Function Split(ByVal con As String) As Dictionary(Of String, String)
            Dim ret As New Dictionary(Of String, String)()
            If con Is Nothing Then
                Return ret
            End If
            Dim lines As String() = con.Split(ControlChars.Lf)
            For Each line As String In lines
                Dim x As String = line.Trim()
                Dim sidx As Integer = x.IndexOf(" "c)
                Dim name As String = ""
                Dim value As String = ""
                If sidx >= 0 Then
                    name = x.Substring(0, sidx)
                    value = x.Substring(sidx + 1).Trim()
                Else
                    name = x
                    value = ""
                End If
                If name <> "" Then
                    ret(name) = value
                End If
            Next
            Return ret
        End Function

        ' return null if failed
        Public Shared Function Decode(ByVal key As String, ByRef task_id As String, ByVal image_fn As String) As String
            task_id = "-1"

            ' read image data
            Dim data As Byte() = File.ReadAllBytes(image_fn)

            ' base64 encode it
            Dim im As String = Convert.ToBase64String(data)

            ' submit captcha to server
            Dim con As String = WebPost("http://bypasscaptcha.com/upload.php", New String() {"key", key, "file", im, "submit", "Submit", _
             "gen_task_id", "1", "base64_code", "1"})
            Dim dict As Dictionary(Of String, String) = Split(con)
            If dict.ContainsKey("TaskId") Then
                task_id = dict("TaskId")
            End If
            If dict.ContainsKey("Value") Then
                Return dict("Value")
            End If
            Return Nothing
        End Function

        Public Shared Sub Feedback(ByVal key As String, ByVal task_id As String, ByVal is_input_correct As Boolean)
            Dim cv As String = "0"
            If is_input_correct Then
                cv = "1"
            End If
            WebPost("http://bypasscaptcha.com/check_value.php", New String() {"key", key, "task_id", task_id, "cv", cv, "submit", "Submit"})
        End Sub

        Public Shared Function Left(ByVal key As String) As Integer
            Dim con As String = WebPost("http://bypasscaptcha.com/ex_left.php", _
                                        New String() {"key", key})
            Dim dict As Dictionary(Of String, String) = Split(con)
            If dict.ContainsKey("Left") Then
                Return Integer.Parse(dict("Left"))
            End If
            Return -1
        End Function

        Public Shared Sub Example()
            ' You need to change this key to your own
            Dim key As String = "85441743985f2df58af91e1b3af4709295a7ddae"
            Dim task_id As String = "-1"
            Dim captcha_fn As String = "captcha.jpg"

            Console.WriteLine("Decoding.")
            Dim value As String = Decode(key, task_id, captcha_fn)
            Console.WriteLine("Decoded value is: {0}", value)
            Console.WriteLine("Suppose we check it as right.")
            Feedback(key, task_id, True)
            Console.WriteLine("OK.")
            Console.WriteLine("There are {0} credits left on this key.", Left(key))
            Console.WriteLine("Press any key to exit.")
            Console.ReadKey()
        End Sub
    End Class

End Module
